<template>
  <v-dialog v-model="dialogDocument" @click:outside="close" max-width="50%">
    <v-card class="pa-8">
      <v-card-title class="justify-center text-h5 d-flex font-weight-bold">
        {{ dialogTitle }}
      </v-card-title>
      <v-divider class="mt-2 mb-6"></v-divider>

      <AdminDocumentsDocumentForm :document="document" />

      <v-card-actions class="justify-center d-flex">
        <v-btn variant="outlined" rounded size="large" class="text-uppercase" data-cy="DocumentFormCancelBtn" @click="close()">
          Annuler
        </v-btn>
        <v-btn variant="outlined" rounded size="large" :disabled="!meta.valid" class="text-uppercase inverted"
          data-cy="DocumentFormOkBtn" :loading="loading" @click="confirm">
          Valider
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { Document } from "~/dto/document.dto";

const dialogDocument = defineModel<boolean>()

const props = defineProps<{
  document: Document
}>()

const emit = defineEmits(['close', 'confirm'])

const { validate, meta } = useForm({
  initialValues: props.document
})

const dialogTitle = ref(props.document.id ? `Édition d'un document` : `Création d'un document`);
const loading = ref(false);

const close = () => {
  emit('close');
};

const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  emit('confirm');
  loading.value = true;
};

</script>
